#include "presaction.hpp"

#include "prescribble.hpp"

namespace Prescribble {

// ======== ComplexAction ==========
ComplexAction::~ComplexAction()
{
    while( !m_subactions.empty() )
    {
        delete m_subactions.back();
        m_subactions.pop_back();
    }
}


bool ComplexAction::undo( Context *a_pContext )
{
    for( ActionList::iterator it = m_subactions.begin();
         it != m_subactions.end();
         it++ )
    {
        if ( (*it)->isDone() )
            (*it)->undo();
    }
    m_done = false;
    return !m_done;
}

bool ComplexAction::redo( Context *a_pContext )
{

    for( ActionList::iterator it = m_subactions.begin();
         it != m_subactions.end();
         it++ )
    {
        if ( !(*it)->isDone() )
            (*it)->redo();
    }
    m_done = true;
    return m_done;
}

void ComplexAction::add( Action& action ){
    m_subactions.push_back( &action );
}



};
