/* File : example.i */

/**

   # change in wrap code:
   # (own) ? VOIDFUNC(sklass->destroy) : 0, ptr);  //from
   # ((own) ? VOIDFUNC(sklass->destroy) : 0), ptr);  //to


   g++ -c prescribble.cpp
   g++ -c presaction.cpp

   swig -c++ -ruby prescribble.i
  
   cat prescribble_wrap.cxx | sed s/"(own) ? VOIDFUNC(sklass->destroy) : 0, ptr);"/"((own) ? VOIDFUNC(sklass->destroy) : 0), ptr);"/ > prescribble_wrap.cpp
   g++ -c prescribble_wrap.cpp -I/usr/lib/ruby/1.6/i386-linux-gnu/ #>x.txt 2>&1 ; less x.txt
   
   g++ -shared prescribble.o prescribble_wrap.o presaction.o -o prescribble.so -lruby

**/

%module prescribble
%{
#include "prescribble.hpp"
  using namespace Prescribble;
%}

//%include "prescribble.hpp"
struct Point2D{
    typedef int CoordValue;
    CoordValue x, y;

    Point2D(int a_x =0, int a_y=0);

    bool isWithinRange( Point2D dst, int range = 0 );
    unsigned int manhattan(Point2D);

    void writeto( my_ostream & out );

  %rename (__add__) operator+;
    Point2D operator+(const Point2D&);

};




struct Rect2D{
    Point2D ul; // upper left
    Point2D br; // bottom right

    enum CollisionType { NONE=0, OVERLAP, OUTSIDE, INSIDE };


   Rect2D( Point2D a, Point2D b );
  %name (new_empty) Rect2D();
  


    void fenceIn( Point2D );

    bool isValid() const;
    bool isWithin( Point2D ) const;
    CollisionType collides( Rect2D ) const;

    int width() const;
    int height() const;

};




class StrokeDrawingContext {
public:
    virtual void drawLine( Point2D, Point2D ) = 0;
    virtual void turnWhite() = 0;
    virtual void turnBlack() = 0;
};



class Stroke {
public:
  
    typedef std::vector<Point2D> Point2DVector;
    typedef std::vector<Stroke*> StrokePtrVector;
    typedef StrokeDrawingContext DrawingContext;

    Point2DVector m_points;
    Rect2D m_boundingRect;

    void add( Point2D p);

    const Rect2D getBoundingRect() const 
        { return m_boundingRect; }


    StrokePtrVector clippingAway( Rect2D , bool keepInside = false);

    void drawAllLines( DrawingContext &a_context );    

    void writeto( my_ostream & out );

};


%include stl.i
/* instantiate the required template specializations */
namespace std {
    %template(Point2DVector)    vector<Point2D>;
    %template(StrokePtrVector)    vector<Stroke*>;
}

// Bugger, the each returns pointers to pointers of Stroke, 
// not poitners to Stroke. Hence this hack.
%extend std::vector<Stroke*> {
      void each_stroke () {
        std::vector<Stroke*>::iterator i1 = self->begin();
        std::vector<Stroke*>::iterator i1end = self->end();
        for ( ; i1!=i1end; i1++){
          rb_yield( SWIG_NewPointerObj((void *) *i1, 
                             SWIGTYPE_p_Stroke, 0));
        }
      }
    }
